//********************************************************************
//*** ResourcePool/TaskRunner/Factory.cc
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: Factory.cc,v 1.6 2009-03-02 14:16:45 mws Exp $
//********************************************************************

#ifndef RESOURCEPOOL_TASKRUNNER_FACTORY_HH
#include "Factory.hh"
#endif

#include <iostream>
#include "ResourcePool/ResourcePoolStreamLogger.hh"

namespace fatalmind {
namespace TaskRunnerPoolInternals {

Factory::Factory()
:observer(new ResourcePoolStreamLogger(std::cerr))
{
}
Resource* Factory::create_resource() const
{
	return new Resource();
}

gc_ptr<ResourcePoolEventObserver> Factory::getEventObserver() const {
	return observer;
}

}
} // namespace fatalmind
