//********************************************************************
//*** ResourcePool/mysql/Transaction.hh
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: Transaction.hh,v 1.4 2009-03-02 14:16:45 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_MYSQL_RESOURCEPOOL_HH
#include "ResourcePool.hh"
#endif

#include <memory>

#ifndef RESOURCEPOOL_MYSQL_TRANSACTION_HH
#define RESOURCEPOOL_MYSQL_TRANSACTION_HH

#ifndef RESOURCEPOOL_COMMAND_HH
#include "ResourcePool/Command.hh"
#endif

//#ifndef RESOURCEPOOL_MYSQL_SQLTYPE_HH
//#include "SQLType.hh"
//#endif

#ifndef RESOURCEPOOL_MYSQL_MYSQLFWD_HH
#include "mysqlFwd.hh"
#endif

#ifndef INCLUDED_GC_PTR_HH
#include "mm/gc_ptr.hh"
#endif

#include <string>

namespace fatalmind {
namespace mysql {

/**
 * The mysql Transaction implementation.
 */
class Transaction
: public Command<fatalmind::ResourceType::mysql>
{
	public:
		Transaction(const Command<fatalmind::ResourceType::mysql>& );
		Transaction(const ResourcePool<ResourceType>& p, const Command<fatalmind::ResourceType::mysql>& );
		Transaction();
		Transaction(const Transaction&);
		virtual ~Transaction();
		virtual void execute(mysqlResource&);

	protected:
		virtual Clone* DoClone() const;
		void startTransaction(mysqlResource&);
		void commit(mysqlResource&);
		void rollback(mysqlResource&);

	private:
		std::auto_ptr<Command<fatalmind::ResourceType::mysql> > cmd;
};


} // namespace mysql
} // namespace fatalmind
#endif
