//********************************************************************
//*** ResourcePool/oracle/Transaction.hh
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: Transaction.hh,v 1.22 2009-03-02 14:16:46 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_ORACLE_TRANSACTION_HH
#define RESOURCEPOOL_ORACLE_TRANSACTION_HH

#ifndef RESOURCEPOOL_ORACLE_COMMANDINTERFACE_HH
#include "CommandInterface.hh"
#endif

#ifndef RESOURCEPOOL_ORACLE_STATEMENTCACHE_HH
#include "StatementCache.hh"
#endif

#ifndef INCLUDED_GC_PTR_HH
#include "mm/gc_ptr.hh"
#endif

namespace fatalmind {
namespace oracle {

template<class TM, template<class> class SLMDC>
class Transaction: public CommandInterface<TM, SLMDC> {
	public:
		/**
		 * Used to create a Transaction command.
		 */
		Transaction(const Command<ResourceType<TM, SLMDC> >& );
		Transaction(const ResourcePool<ResourceType<TM> >& p, const Command<ResourceType<TM, SLMDC> >&);
		Transaction();
		Transaction(const Transaction<TM, SLMDC>&);
		virtual ~Transaction();

//		virtual void execute(oracleResource<TM>& hand);

	protected:
		virtual Clone* DoClone() const;
		virtual void _execute(oracleResource<TM>&, StatementCache&);
		void commit(oracleResource<TM>&);
		void rollback(oracleResource<TM>&);
	private:
		std::auto_ptr<Command<ResourceType<TM, SLMDC> > > cmd;
};

} // namespace oracle
} // namespace fatalmind
#endif
