//********************************************************************
//*** ResourcePool/mm/RawBuffer.hh
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: RawBuffer.hh,v 1.3 2009-03-02 14:16:47 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef FATALMIND_MM_RAWBUFFER_HH
#define FATALMIND_MM_RAWBUFFER_HH

#include <new>
namespace fatalmind {

class RawBuffer {
	public:
		RawBuffer();
		RawBuffer(size_t size);
		~RawBuffer();

		void allocate(size_t size);

		inline void* get() const throw () {
			return ptr;
		}
	private:
		void* ptr;
};

}; // namespace fatalmind
#endif
